
package cn.zijinshi.cvs.actions;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.team.internal.ccvs.ui.CVSUIMessages;
import org.eclipse.team.internal.ccvs.ui.IHelpContextIds;
import org.eclipse.team.internal.ccvs.ui.actions.OutgoingChangesDialog;
import org.eclipse.team.internal.ccvs.ui.actions.TagAction;
import org.eclipse.team.internal.ccvs.ui.operations.ITagOperation;

import cn.zijinshi.cvs.core.ICVSUICons;
import cn.zijinshi.cvs.operations.RemoveTagOperation;
import cn.zijinshi.cvs.ui.dialogs.TagRemoveDialog;

/**
 * @author Administrator
 * 
 */
@SuppressWarnings("restriction")
public class RemoveTagAction extends TagAction
{

	// /**
	// * Returns the default shell used by dialogs
	// *
	// * @return the active shell of the current display
	// */
	// public static Shell getDefaultShell( )
	// {
	// Shell shell = null;
	// try
	// {
	// shell = PlatformUI.getWorkbench( ).getDisplay( ).getActiveShell( );
	// if ( shell == null )
	// {
	// shell = Display.getCurrent( ).getActiveShell( );
	// }
	// if ( shell == null )
	// {
	// shell = PlatformUI.getWorkbench( )
	// .getActiveWorkbenchWindow( )
	// .getShell( );
	// }
	// }
	// catch ( Exception e )
	// {
	// }
	// if ( shell == null )
	// {
	// return new Shell( );
	// }
	// return shell;
	// }

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.team.internal.ccvs.ui.actions.TagAction#performPrompting(
	 * org.eclipse.team.internal.ccvs.ui.operations.ITagOperation)
	 */
	protected boolean performPrompting( ITagOperation operation )
	{
		if ( operation instanceof RemoveTagOperation )
		{
			final RemoveTagOperation tagOperation = (RemoveTagOperation) operation;
			try
			{
				if ( hasOutgoingChanges( tagOperation ) )
				{
					final boolean[] keepGoing = new boolean[]{
						true
					};
					Display.getDefault( ).syncExec( new Runnable( ) {

						public void run( )
						{
							OutgoingChangesDialog dialog = new OutgoingChangesDialog( getShell( ),
									tagOperation.getScopeManager( ),
									CVSUIMessages.TagLocalAction_2,
									CVSUIMessages.TagLocalAction_0,
									"" ); //$NON-NLS-1$
							dialog.setHelpContextId( IHelpContextIds.TAG_OUTGOING_CHANGES_DIALOG );
							int result = dialog.open( );
							keepGoing[0] = result == Window.OK;
						}
					} );
					return keepGoing[0];
				}
				return true;
			}
			catch ( InterruptedException e )
			{
				// Ignore
			}
			catch ( InvocationTargetException e )
			{
				handle( e );
			}
		}
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.team.internal.ccvs.ui.actions.TagAction#createTagOperation()
	 */
	protected ITagOperation createTagOperation( )
	{
		return new RemoveTagOperation( getTargetPart( ),
				getCVSResourceMappings( ) );
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.team.internal.ccvs.ui.actions.CVSAction#getId()
	 */
	public String getId( )
	{
		return ICVSUICons.CMD_REMOVETAG;
	}

	/**
	 * Prompts the user for a tag name. Note: This method is designed to be
	 * overridden by test cases.
	 * 
	 * @return the operation, or null to cancel
	 */
	protected ITagOperation configureOperation( )
	{
		// IPreferenceStore store =
		// CVSUIPlugin.getPlugin().getPreferenceStore();
		ITagOperation operation = createTagOperation( );
		if ( operation.isEmpty( ) )
		{
			return null;
		}
		if ( !performPrompting( operation ) )
		{
			return null;
		}
		TagRemoveDialog dialog = new TagRemoveDialog( getShell( ),
		// CVSUIMessages.TagAction_tagResources,
				"Remove Tag",
				operation );
		if ( dialog.open( ) != Window.OK )
			return null;

		// // The user has indicated they want to force a move. Make sure they
		// really do.
		// if (dialog.shouldMoveTag() &&
		// store.getBoolean(ICVSUIConstants.PREF_CONFIRM_MOVE_TAG)) {
		// MessageDialogWithToggle confirmDialog =
		// MessageDialogWithToggle.openYesNoQuestion(getShell(),
		// CVSUIMessages.TagAction_moveTagConfirmTitle,
		// NLS.bind(CVSUIMessages.TagAction_moveTagConfirmMessage, new String[]
		// { dialog.getTagName() }),
		// null,
		// false,
		// null,
		// null);
		//			
		// if (confirmDialog.getReturnCode() == IDialogConstants.YES_ID) {
		// store.setValue(ICVSUIConstants.PREF_CONFIRM_MOVE_TAG,
		// !confirmDialog.getToggleState());
		// } else {
		// return null;
		// }
		// }

		// The user is a cowboy and wants to do it.
		return dialog.getOperation( );
	}

}
